package vic;
// PNG file format info structure definition (used by pnginfo)
public class PngData{
   public int width;  // PNG image width, length
   public int length;
   public int bitDepth;    // Bits per pixel, 1, 2, 4, 8, or 16
   public int vbitcount;   // Victor bits per pixel
   public int colorType;   // Color types: 0=GS, 2=RGB, 3=PalCol, 4=GS+alpha, 6=RGB+alpha
   public int interlaced;  // 0 => non-interlaced, 1 => interlaced
   public int imageId;     // Unique identifier for colorType/bitDepth
   public int channels;    // Number of channels of data per pixel
   public int pixelDepth;  // Number of bits per pixel
   public int rowBytes;  // Bytes in one image row
   // PNGTRANSINFO transData; // Transparency data
   public int transData_isPresent;   // TRUE if transparency data is present
   public byte transData_data0;
   public byte transData_data1;
   public byte transData_data2;
   public byte transData_data3;
   public byte transData_data4;
   public byte transData_data5;    // Up to 6 bytes of transparency data
   public int transData_byteCount;   // Bytes of transparency data
   // PNGTRANSINFO backData;  // Background color data
   public int backData_isPresent;   // TRUE if background data is present
   public byte backData_data0;
   public byte backData_data1;
   public byte backData_data2;
   public byte backData_data3;
   public byte backData_data4;
   public byte backData_data5;    // Up to 6 bytes of backparency data
   public int backData_byteCount;   // Bytes of background data
   public int igamma;    // Gamma as float = igamma / 100000   
   public int physXres;  // X,Y axis pixels per unit
   public int physYres;
   public int physUnits;
   // PNGSIGBITS sigBit;  // Significant bits in file
   public int sigBit_sb_long; 
   public int offsXoffset; // X,Y axis offset
   public int offsYoffset;
   public byte offsUnits;
}
