import vic.*;
import java.io.IOException; // For code that delays ending the program	  

/*

	javac -classpath e:\java bmp2jpeg.java
	java -classpath e:\java;e:\java\vic bmp2jpeg

*/

class bmp2jpeg {

	public static void main(String args[]) {

   String loadfilename;
   String savefilename;
	int rcode = 0; 
   vic.imgdes timage = new vic.imgdes();
	vic.BITMAPINFOHEADER filedata = new vic.BITMAPINFOHEADER();

	rcode = vic.vic32jni.enableunicode(1);  // Turn on Unicode if available

	// load bmp save as jpeg
	loadfilename = "test.bmp";
	savefilename = "test.jpg";
	rcode = vic.vic32jni.bmpinfo(loadfilename, filedata);
	if(rcode == vic.vic32jni.NO_ERROR) {
		rcode = vic.vic32jni.allocimage(timage, filedata.biWidth, filedata.biHeight, (int)filedata.biBitCount);

		if(rcode == vic.vic32jni.NO_ERROR) {
			System.out.println("Allocation successful, loading bmp file");
			System.out.println("  image width in pixels = " + filedata.biWidth);
			System.out.println("  image length in pixels = " + filedata.biHeight);
			System.out.println("  buffer width in bytes = " + timage.buffwidth);
			rcode = vic32jni.loadbmp(loadfilename, timage);
			if(rcode == vic.vic32jni.NO_ERROR) {
				System.out.println("File load successful, saving jpeg file");
				if(timage.bibitcount == 1) 
					rcode = convert2grayscale(timage);

				rcode = vic.vic32jni.savejpg(savefilename, timage, 75);
				System.out.println("Filesave rcode = " + rcode);
				}
			}
		if(rcode == 0)
			vic.vic32jni.freeimage(timage);
		}
	} // end of main()


	public static void displayimgdes(imgdes rimage) {

	System.out.println("     Image buffer address        " + rimage.ibuff);        
   System.out.println("     Image area to be processed  " + rimage.stx +", "+ rimage.sty +", "+ rimage.endx +", "+ rimage.endy); 
   System.out.println("     Image buffer width in bytes " + rimage.buffwidth);    
   System.out.println("     Address of palette          " + rimage.palette);      
   System.out.println("     Palette colors              " + rimage.colors);       
   System.out.println("     Image type                  " + rimage.imgtype);      
   System.out.println("     BITMAPINFOHEADER address    " + rimage.bmh);          
   System.out.println("     DIB handle                  " + rimage.hBitmap);      
   System.out.println("     Pixel width of image        " + rimage.biwidth);      
   System.out.println("     Pixel length of image       " + rimage.biheight);     
   System.out.println("     Pixel depth of image        " + rimage.bibitcount);   

	}


	public static int convert2grayscale(imgdes rimage) {
	vic.imgdes grayimage = new vic.imgdes();
	int rcode;

	System.out.println("Converting from 1- to 8-bit");
	rcode = vic.vic32jni.allocimage(grayimage, rimage.biwidth, rimage.biheight, 8);
	if(rcode == vic.vic32jni.NO_ERROR) {
		rcode = vic.vic32jni.convert1bitto8bit(rimage, grayimage);
		if(rcode == vic.vic32jni.NO_ERROR) {
			System.out.println("Conversion successful");
			System.out.println("1-bit image:");
			displayimgdes(rimage);
			System.out.println("8-bit image:");
			displayimgdes(grayimage);
			vic.vic32jni.freeimage(rimage);
			vic.vic32jni.copyimgdes(grayimage, rimage);
			System.out.println("Replacing original image with:");
			displayimgdes(rimage);
			}
		}
	return(rcode);	// 8-bit image replaces the original 1-bit image
	}

}