package vic;

/*
	vic32jni.java 
	Definitions and function prototypes for function calls 
	into the Victor Image Processing Library vic32.dll via vic32jni.dll from Java

	(c) copyright 2001, Catenary Systems Inc
	url:   www.catenary.com
	email: support@catenary.com

	javac -classpath e:\java vic32jni.java
	javah -classpath e:\java vic.vic32jni.java

*/



// ..................
public class vic32jni {
	
   // Vic32 prototypes
	public static native int addimage(imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int allocimage(imgdes image, int width, int length, int bppixel);
	public static native int allocDIB(imgdes image, int width, int length, int bppixel);
	public static native int andimage(imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int blur(imgdes srcimg, imgdes desimg);
	public static native int blurthresh(int thres, imgdes srcimg, imgdes desimg);
	public static native int bmpinfo(String fname, BITMAPINFOHEADER bdat);
	public static native int bmpinfofrombuffer(int buffaddr, BITMAPINFOHEADER bdat);
	public static native int brightenmidrange(imgdes srcimg, imgdes desimg);
	public static native int calcavglevel(imgdes srcimg, refvar redavg, refvar grnavg, refvar bluavg);
	public static native int calchisto(imgdes srcimg, int[] redtab, int[] grntab, int[] blutab);
	public static native int calchistorgb(imgdes srcimg, int[] redtab, int[] grntab, int[] blutab, int mode);
	public static native int changebright(int amt, imgdes srcimg, imgdes desimg);
	public static native int clienttoimage(int hWnd, imgdes image);
	public static native int colordither(imgdes srcimg, imgdes desimg, int colorMode);
	public static native int colorscatter(imgdes srcimg, imgdes desimg, int colorMode);
	public static native int colortogray(imgdes srcimg, imgdes desimg);
	public static native int convert1bitto8bit(imgdes srcimg, imgdes desimg);
	public static native int convert1bitto8bitsmooth(imgdes srcimg, imgdes desimg);
	public static native int convert8bitto1bit(int mode, imgdes srcimg, imgdes desimg);
	public static native int convertgray16to8(imgdes srcimg, imgdes desimg);
	public static native int convertgray8to16(imgdes srcimg, imgdes desimg);
	public static native int convertpaltorgb(imgdes srcimg, imgdes desimg);
	public static native int convertrgbtopal(int palcolors, imgdes srcimg, imgdes desimg);
	public static native int convertrgbtopalex(int palcolors, imgdes srcimg, imgdes desimg, int mode);
	public static native int copyimage(imgdes srcimg, imgdes desimg);
	public static native int copyimagebits(imgdes srcimg, imgdes desimg);
	public static native void copyimagepalette(imgdes srcimg, imgdes desimg);
	public static native void copyimgdes(imgdes srcimg, imgdes desimg);
	public static native int cover(int thres, imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int coverclear(int transColor, imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int ddbtoimage(int hBitmap, int hPal, imgdes image);
	public static native int defaultpalette(imgdes srcimg);
	public static native int dibsecttoimage(int hBitmap, imgdes image);
	public static native int dibtobitmap(int hdc, int dibaddr, refvar hBitmap);
	public static native int dibtoimage(int dibaddr, imgdes desimg);
	public static native int dilate(int amt, imgdes srcimg, imgdes desimg);
	public static native int divide(int divsr, imgdes srcimg, imgdes desimg);
	public static native int drawhisto(int hdc, RECT rect, int bppixel, int[] redtab, int[] grntab, int[] blutab);
	public static native int erode(int amt, imgdes srcimg, imgdes desimg);
	public static native int exchangelevel(int min, int max, int newval, imgdes srcimg, imgdes desimg);
	public static native int expandcontrast(int min, int max, imgdes srcimg, imgdes desimg);
	public static native int flipimage(imgdes srcimg, imgdes desimg);
	public static native void freeimage(imgdes image);
	public static native int gammabrighten(double amt, imgdes srcimg, imgdes desimg);
	public static native int getgifcomment(String fname, char[] commentstring, int maxbuf);
	public static native int getpngcomment(String fname, String commenttype, char[] commentstring, int maxbuf);
	public static native int getpixelcolor(imgdes image, int xcoord, int ycoord);
	public static native int gifinfo(String fname, GifData ginfo);
	public static native int gifinfofrombuffer(int buffaddr, GifData ginfo);
	public static native int gifframecount(String fname, refvar totalFrames);
	public static native int gifframecountfrombuffer(int buffaddr, refvar totalFrames);
	public static native int gifinfoallframes(String  fname, GifGlobalData gdata, GifFrameData fdata, int frameElem);
	public static native int gifinfoallframesfrombuffer(int buffaddr, GifGlobalData gdata, GifFrameData fdata, int frameElem);
	public static native int gifinfoframe(String  fname, GifData ginfo, GifGlobalData gdata, GifFrameData fdata, int frameTarget);
	public static native int gifinfoframefrombuffer(int buffaddr, GifData ginfo, GifGlobalData gdata, GifFrameData fdata, int frameTarget);
	public static native int histobrighten(vic.imgdes srcimg, imgdes desimg);
	public static native int histoequalize(imgdes srcimg, imgdes desimg);
	public static native int hsv2rgb(HSVTRIPLE[] hsvpal, RGBQUAD[] rgbpal, int colors);
	public static native void imageareatorect(imgdes image, RECT rect);
	public static native int imagetodib(imgdes srcimg, refvar dibaddr);
	public static native int isgrayscaleimage(imgdes image);
	public static native int jpeggeterror();
	public static native int jpeginfo(String fname, JpegData jdat);
	public static native int jpeginfoex(String fname, JpegDataEx jdat);
	public static native int jpeginfofrombuffer(int buffaddr, JpegData jinfo);
	public static native int jpeginfofrombufferex(int buffaddr, JpegDataEx jinfo);
	public static native void jpegsetxyresolution(int xres, int yres, int resUnit);
	public static native int jpegsetthumbnailsize(int longEdge);
	public static native int kodalith(int thres, imgdes srcimg, imgdes desimg);
	public static native int limitlevel(int thres, imgdes srcimg, imgdes desimg);
	public static native int loadbif(String fname, imgdes desimg);
	public static native int loadbmp(String fname, imgdes image);
	public static native int loadbmpfrombuffer(int buffaddr, imgdes desimg);
	public static native int loadbmppalette(String fname, RGBQUAD[] paltab);
	public static native int loadbmppalettefrombuffer(int buffaddr, RGBQUAD[] paltab);
	public static native int loadgif(String fname, imgdes desimg);
	public static native int loadgiffrombuffer(int buffaddr, imgdes desimg);
	public static native int loadgifpalette(String fname, RGBQUAD[] paltab);
	public static native int loadgifpalettefrombuffer(int buffaddr, RGBQUAD[] paltab);
	public static native int loadgifpaletteframe(String fname, RGBQUAD[] paltab, int frame);
	public static native int loadgifpaletteframefrombuffer(int buffaddr, RGBQUAD[] paltab, int frame);
	public static native int loadgifframe(String fname, imgdes desimg,GifGlobalData gdata, GifFrameData fdata);
	public static native int loadgifframefrombuffer(int buffaddr, imgdes desimg, GifGlobalData gdata, GifFrameData fdata);
	public static native int loadgifglobalpalette(String fname, RGBQUAD[] paltab);
	public static native int loadgifglobalpalettefrombuffer(int buffaddr, RGBQUAD[] paltab);
	public static native int loadgifframepalette(String fname, RGBQUAD[] paltab, int frame);
	public static native int loadgifframepalettefrombuffer(int buffaddr, RGBQUAD[] paltab, int frame);
	public static native int loadjpg(String fname, imgdes desimg);
	public static native int loadjpgfrombuffer(int buffaddr, imgdes desimg);
	public static native int loadjpgthumbnail(String fname, imgdes desimg, int createThumbNail);
	public static native int loadjpgthumbnailfrombuffer(int buffaddr, imgdes desimg, int createThumbNail);
	public static native int loadpcx(String fname, imgdes desimg);
	public static native int loadpcxpalette(String fname, RGBQUAD[] paltab);
	public static native int loadpng(String fname, imgdes desimg);
	public static native int loadpngfrombuffer(int buffaddr, imgdes desimg);
	public static native int loadpngpalette(String fname, RGBQUAD[] paltab);
	public static native int loadpngpalettefrombuffer(int buffaddr, RGBQUAD[] paltab);
	public static native int loadtga(String fname, imgdes desimg);
	public static native int loadtgapalette(String fname, RGBQUAD[] paltab);
	public static native int loadtif(String fname, imgdes desimg);
	public static native int loadtifpage(String fname, imgdes desimg, int page);
	public static native int loadtifpagebyindex(String fname, imgdes desimg, int pageIndex);
	public static native int loadtiffrombuffer(int buffaddr, imgdes desimg);
	public static native int loadtifpalette(String fname, RGBQUAD[] paltab);
	public static native int loadtifpalettepage(String fname, RGBQUAD[] paltab, int page);
	public static native int loadtifpalettepagebyindex(String fname, RGBQUAD[] paltab, int pageIndex);
	public static native int loadtifpalettefrombuffer(int buffaddr, RGBQUAD[] paltab);
	public static native int matchcolorimage(imgdes srcimg, imgdes desimg);
	public static native int matchcolorimageex(imgdes srcimg, imgdes desimg, int mode);
	public static native int matrixconv(byte[] kernel, imgdes srcimg, imgdes desimg);
	public static native int matrixconvex(int ksize, byte[] kernel, int divsr, imgdes srcimg, imgdes desimg);
	public static native int medianfilter(int ksize, imgdes srcimg, imgdes desimg);
	public static native int mirrorimage(imgdes srcimg, imgdes desimg);
	public static native int multiply(int multr, imgdes srcimg, imgdes desimg);
	public static native int negative(imgdes srcimg, imgdes desimg);
	public static native int orimage(imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int outline(imgdes srcimg, imgdes desimg);
	public static native int pcxinfo(String fname, PcxData pdata);
	public static native int pnggeterror();
	public static native int pnggetxyresolution(String fname, refvar xres, refvar yres, refvar resUnit);
	public static native void pngsetxyresolution(int xres, int yres, int resUnit);
	public static native int pnginfo(String fname, PngData pdat);
	public static native int pnginfofrombuffer(int buffaddr, PngData pdat);
	public static native int pixelcount(int min, int max, refvar redct, refvar grnct, refvar bluct, imgdes srcimg);
	public static native int pixellize(int factr, imgdes srcimg, imgdes desimg);
	public static native int printimage(int hwnd, int hdcprn, int mode, imgdes image, RECT rect, int boxsiz, DSPFCT dspfct);
	public static native void printimageenddoc(int hdcprn, int ejectPage);
	public static native int printimagenoeject(int hwnd, int hdcprn, int mode, imgdes image, RECT rect, int boxsiz, DSPFCT dspfct);
	public static native int printimagestartdoc(int hdcPrn, String aDocname);
	public static native int rainbowpalette(imgdes srcimg);
	public static native int recttoimagearea(RECT rect, imgdes image);
	public static native int reduceimagecolors(imgdes srcimg, imgdes desimg);
	public static native int removenoise(imgdes srcimg, imgdes desimg);
	public static native int resize(imgdes srcimg, imgdes desimg);
	public static native int resizeex(imgdes srcimg, imgdes desimg, int resizeMode);
	public static native int rgb2hsv(RGBQUAD rgbpal, HSVTRIPLE hsvpal, int colors);
	public static native int rotate(double angle, imgdes srcimg, imgdes desimg);
	public static native int rotate90(int dir, imgdes srcimg, imgdes desimg);
	public static native int savebif(String fname, imgdes srcimg);
	public static native int savebmp(String fname, imgdes srcimg, int cmp);
	public static native int savebmptobuffer(refvar buffaddr, imgdes srcimg, int cmp);
	public static native int saveeps(String fname, imgdes srcimg);
	public static native int savegif(String fname, imgdes srcimg);
	public static native int savegifex(String fname, imgdes srcimg, int mode, int transColor);
	public static native int savegiftobufferex(refvar buffaddr, imgdes srcimg, int mode, int transColor);
	public static native int savegifframe(String fname, imgdes srcimg, GifGlobalSaveData gdata, GifFrameSaveData fdata, int mode);
	public static native int savejpg(String fname, imgdes srcimg, int qual);
	public static native int savejpgex(String fname, imgdes srcimg, int qual, int savemode);
	public static native int savejpgtobuffer(refvar buffaddr, imgdes srcimg, int qual);
	public static native int savejpgtobufferex(refvar buffaddr, imgdes srcimg, int qual, int savemode);
	public static native int savepcx(String fname, imgdes srcimg);
	public static native int savepng(String fname, imgdes srcimg, int cmp);
	public static native int savepngtobuffer(refvar buffaddr, imgdes srcimg, int compsn);
	public static native int savetga(String fname, imgdes srcimg, int cmp);
	public static native int savetif(String fname, imgdes srcimg, int cmp);
	public static native int savetifpage(String fname, imgdes srcimg, int cmprsn, int page);
	public static native int savetiftobuffer(refvar buffaddr, imgdes srcimg, int cmprsn);
	public static native void setgifcomment(int version, String comment);
	public static native int setimagearea(imgdes image, int stx, int sty, int endx, int endy);
	public static native int setpixelcolor(imgdes image, int xcoord, int ycoord, int level);
	public static native int setupimgdes(int dibaddr, imgdes image);
	public static native int sharpen(imgdes srcimg, imgdes desimg);
	public static native int sharpengentle(imgdes srcimg, imgdes desimg);
	public static native int standardpalette(imgdes srcimg);
	public static native int subimage(imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int tgainfo(String fname, TgaData tdat);
	public static native int threshold(int thres, imgdes srcimg, imgdes desimg);
	public static native int tiffgetpageinfo(String fname, refvar totalPages, int[] pageArray, int arrayElems);
	public static native int tiffgetxyresolution(String fname, refvar xres, refvar yres, refvar resUnit);
   public static native int tiffgetxyresolutionpagebyindex(String fname, refvar xres, refvar yres, refvar resUnit, int targetPage);

	public static native int tiffgeterror();
	public static native int tiffinfo(String fname, TiffData tdat);
	public static native int tiffinfopage(String fname, TiffData tdat, int page);
	public static native int tiffinfopagebyindex(String fname, TiffData tdat, int pageIndex);
	public static native int tiffinfofrombuffer(int buffaddr, TiffData tdat);
	public static native void tiffsetxyresolution(int xres, int yres, int resUnit);
	public static native void unlockLZW(int dwKey);
	public static native int updatebitmapcolortable(imgdes srcimg);
	public static native int usetable(byte[] redtab, byte[] grntab, byte[] blutab, imgdes srcimg, imgdes desimg);
	public static native short Victorversion();
	public static native short Victorversionex(VIC_VERSION_INFO vicVerInfo);
	public static native int victowinpal(imgdes srcimg, refvar hPal);
	public static native int viewimage(int hwnd, int hdc, refvar hPal, int xpos, int ypos, imgdes image);
	public static native int viewimageex(int hwnd, int hdc, refvar hPal, int xpos, int ypos, imgdes image, int scrx, int scry, int colRedMode);
	public static native int windowtoimage(int hWnd, imgdes image);
	public static native int wintovicpal(int hPal, imgdes desimg);
	public static native int wtaverage(int prct, imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int xorimage(imgdes srcimg, imgdes oprimg, imgdes desimg);
	public static native int zeroimage(int level, imgdes image);
	public static native void zeroimgdes(imgdes image);
	public static native void TWclose();

   // Victw32 prototypes
	public static native int TWdetecttwain(int hWnd);
	public static native int TWgetbrightness(int hWnd, TWAIN_CAP_DATA brightness);
	public static native int TWgetcontrast(int hWnd, TWAIN_CAP_DATA contrast);
	public static native int TWgetfeeder(int hWnd, refvar feederIsEnabled, refvar feederHasPaper);
	public static native int TWgeterror();
	public static native int TWgetmeasureunit(int hWnd, TWAIN_CAP_DATA typeUnit);
	public static native int TWgetphysicalsize(int hWnd, refvar width,  refvar height);
	public static native int TWgetpixeltype(int hWnd, TWAIN_CAP_DATA pixelType);
	public static native int TWgetsourcenames(int hWnd, char[] nameList, refvar Count_of_34CharNames);
	public static native int TWgetxresolution(int hWnd, TWAIN_CAP_DATA xRes);
	public static native int TWgetyresolution(int hWnd, TWAIN_CAP_DATA yRes);
	public static native int TWopen(int hWnd);
	public static native int TWscancountimages(int hWnd, imgdes desimg, RECT pRect, int showIU, int maxPages,SCNFCT saveScan);
	public static native int TWscanimage(int hWnd, imgdes desimg);
	public static native int TWscanimageex(int hWnd, imgdes desimg, RECT pRect, int showIU);
	public static native int TWscanmultipleimages(int hWnd, imgdes desimg,SCNFCT saveScan);
	public static native int TWscanmultipleimagesex(int hWnd, imgdes desimg, RECT pRect, int showIU,SCNFCT saveScan);
	public static native int TWselectsource(int hWnd);
	public static native int TWselectsourcebyname(int hWnd, String dsName);
	public static native int TWsetbrightness(int hWnd, TWAIN_CAP_DATA brightness);
	public static native int TWsetcontrast(int hWnd, TWAIN_CAP_DATA contrast);
	public static native int TWsetduplex(int hWnd, int enableDuplex);
	public static native int TWsetfeeder(int hWnd, int enableFeeder);
	public static native int TWsetpagesize(int hWnd, int pageConst);
	public static native int TWsetpixeltype(int hWnd, TWAIN_CAP_DATA pixelType);
	public static native int TWsetmeasureunit(int hWnd, TWAIN_CAP_DATA typeUnit);
	public static native int TWsetxresolution(int hWnd, TWAIN_CAP_DATA xRes);
	public static native int TWsetyresolution(int hWnd, TWAIN_CAP_DATA yRes);
	public static native void TWsetproductname(String prodName);
	public static native short TWvicversion();


   // Helper functions
	public static native int enableunicode(int mode);
	public static native int GetPrinterDC();
	public static native int getBitmapinfoheaderData(int bmhHdrAddr, BITMAPINFOHEADER jbmphdr);

   // Useful win32 functions and macros
	public static native int GetActiveWindow();
	public static native int GetDesktopWindow();
	public static native int GetDC(int hwnd);
	public static native int ReleaseDC(int hwnd, int hdc);
	public static native int DeleteObject(int hpalvalue);
	public static native int calloc(int num, int sizeinbytes); // returns memoryaddress
	public static native void free(int memoryaddress );
	public static native int memcpy(int destaddress, int srcaddress, int countbytes); // returns destaddress

	// For savexxxtobuffer buffers
	public static native int GlobalFreePtr(int bufferaddress); 
	public static native int GlobalPtrHandle(int bufferaddress); // returns hmem, the memoryhandle
	public static native int GlobalSize(int hmem); // returns size of memory

   public static native byte[] convertbuffertobytearray(int bufferaddress, int buffersize);

	// Return codes
	public static final int NO_ERROR    =  0      ;
	public static final int BAD_RANGE   = -1      ;/* Range error */
	public static final int NO_DIG      = -2      ;/* Digitizer board not detected */
	public static final int BAD_DSK     = -3      ;/* Disk full, file not written */
	public static final int BAD_OPN     = -4      ;/* Filename not found */
	public static final int BAD_FAC     = -5      ;/* Non-dimensional variable out of range */
	public static final int BAD_TIFF    = -6      ;/* Unreadable TIF format */
	public static final int TIFF_NOPAGE= -51      ;/* TIF page not found */
	public static final int TIFF_MOTYPE= -69      ;/* Can't append an Intel-type TIF to a Motorola-type TIF */
	public static final int BAD_BPS     = -8      ;/* TIF bits per sample not supported */
	public static final int BAD_CMP     = -9      ;/* Unreadable compression scheme */
	public static final int BAD_CRT    = -10      ;/* Cannot create file */
	public static final int BAD_FTPE   = -11      ;/* Unknown file format */

	public static final int BAD_DIB    = -12      ;/* Device independent bitmap is compressed */
	public static final int VMODE_ERR  = -13      ;/* Invalid video mode */
	public static final int BAD_MEM    = -14      ;/* Insufficient memory for function */
	public static final int BAD_PIW    = -15      ;/* Not PIW format */
	public static final int BAD_PCX    = -16      ;/* Unreadable PCX format */
	public static final int BAD_GIF    = -17      ;/* Unreadable GIF format */
	public static final int GIF_NOFRAME= -71      ;/* GIF frame not found */
	public static final int PRT_ERR    = -18      ;/* Print error */
	public static final int PRT_BUSY   = -41      ;/* Printimage() is busy */
	public static final int SCAN_ERR   = -19      ;/* Scanner error */

	public static final int BAD_TGA    = -25      ;/* Unreadable TGA format */
	public static final int BAD_BPP    = -26      ;/* Bits per pixel not supported */
	public static final int BAD_BMP    = -27      ;/* Unreadable BMP format */
	public static final int BAD_JPEG   = -43      ;/* Unreadable JPEG format */
	public static final int TOO_CPLX   = -44      ;/* Image is too complex to complete operation */
	public static final int NOT_AVAIL  = -50      ;/* Function not available due to missing module */
	public static final int LZW_DISABLED= -53     ;/* LZW functionality disabled */
	public static final int BAD_DATA    = -62     ;/* File contains invalid data */
	public static final int BAD_PNG     = -63     ;/* Unreadable PNG format */
	public static final int BAD_PNG_CMP = -64     ;/* PNG compressor error */
	public static final int NO_ACK      = -65     ;/* No ACK from digitizer */
	public static final int BAD_HANDLE  = -68     ;/* Handle not valid */
	public static final int BAD_TN_SIZE = -70     ;/* Thumbnail size out of range */
	public static final int BAD_DIGI_MEM= -72     ;/* Insufficient digitizer memory for selected mode */
	public static final int BAD_DIM     = -73     ;/* Image format does not support width or length > 65535 */

	/* Scanner ADF error codes */
	public static final int SCAN_UNLOAD   = -45   ;// paper could not be unloaded from ADF
	public static final int SCAN_LIDUP    = -46   ;// ADF lid was opened
	public static final int SCAN_NOPAPER  = -47   ;// ADF bin is empty
	public static final int SCAN_NOADF    = -48   ;// ADF is not connected,
	public static final int SCAN_NOTREADY = -49   ;// ADF is connected but not ready

	/* Device error codes */
	public static final int COM_ERR    = -31      ;/* Serial data reception error */
	public static final int BAD_COM    = -32      ;/* No data from COM port */
	public static final int NO_DEV_DATA= -33      ;/* No data from device */
	public static final int TIMEOUT    = -34      ;/* Function timed out */
	//  Critical errors
	public static final int TWAIN_NOWND= -54      ;/* Could not create Twain parent window */
	public static final int TWAIN_NODSM= -55      ;/* Could not open Twain Source Manager */
	public static final int TWAIN_NODS = -56      ;/* Could not open Twain Data Source */
	public static final int TWAIN_ERR  = -57      ;/* Twain image acquisition error */
	public static final int TWAIN_NOMATCH= -58    ;/* None of the elements in two lists were equal */
	public static final int TWAIN_BAD_DATATYPE= -59 ;/* Data type mismatch */
	public static final int TWAIN_SCAN_CANCEL= -60 ;/* User cancelled scan */
	public static final int TWAIN_BUSY = -61      ;/* Twain function is busy */
	public static final int TWAIN_NO_PAPER= -66   ;/* Auto feeder is empty */
	public static final int TWAIN_STOP_SCAN= -67  ;/* Stop scanning images */
	// Twain image acquisition errors
	public static final int TWAIN_FIRST_ERR = TWAIN_NOWND;
	public static final int TWAIN_LAST_ERR  = TWAIN_STOP_SCAN;

	// Png extended error codes (available when rcode == BAD_PNG)
	public static final int PNG_ERR_UNK_CRIT_CHK = -100 ;// Unknown critical chunk
	public static final int PNG_ERR_TOO_FEW_IDATS= -101 ;// Not enough IDATs for image
	public static final int PNG_ERR_INV_IHDR_CHK = -102 ;// Invalid IHDR chunk
	public static final int PNG_ERR_INV_BITDEPTH = -103 ;// Invalid bit depth in IHDR
	public static final int PNG_ERR_INV_COLORTYPE= -104 ;// Invalid color type in IHDR
	public static final int PNG_ERR_INV_BITCOL   = -105 ;// Invalid color type/bit depth combo in IHDR
	public static final int PNG_ERR_INV_INTERLACE= -106 ;// Invalid interlace method in IHDR
	public static final int PNG_ERR_INV_COMP     = -107 ;// Invalid compression method in IHDR
	public static final int PNG_ERR_INV_FILTER   = -108 ;// Invalid filter method in IHDR
	public static final int PNG_ERR_IMAGE_SIZE   = -109 ;// Invalid image size in IHDR
	public static final int PNG_ERR_BAD_SIG      = -110 ;// Bad PNG signature
	public static final int PNG_ERR_BAD_CRC      = -111 ;// Bad CRC value
	public static final int PNG_ERR_TOO_MUCH_DATA= -112 ;// Extra data at end of file
	public static final int PNG_ERR_EARLY_EOF    = -113 ;// Unexpected End Of File
	public static final int PNG_ERR_MEM_ERR      = -114 ;// Memory error
	public static final int PNG_ERR_DECOMPRESSION= -115 ;// Decompression error
	public static final int PNG_ERR_COMPRESSION  = -116 ;// Compression error
	public static final int PNG_ERR_NO_DISK_SPACE= -117 ;// Out of disk space

	// Jpeg extended error codes (available when rcode == BAD_JPEG)
	public static final int JPG_BAD_PRECISION  = -100 ;// Sample precision is not 8
	public static final int JPG_BAD_EOF        = -101 ;// Unexpected End Of File
	public static final int JPG_BAD_RESTART    = -102 ;// Reset marker could not be found
	public static final int JPG_INVALID_MARKER = -103 ;// Invalid marker found in the image data
	public static final int JPG_READ_ERR       = -104 ;// Error reading data from the file
	public static final int JPG_INVALID_DATA   = -105 ;// Invalid data found in JPEG file
	public static final int JPG_BAD_COMPINFO   = -106 ;// Component info out of bounds
	public static final int JPG_BAD_BLOCKNO    = -107 ;// Blocks in an MCU is > 10
	public static final int JPG_BAD_BPPIXEL    = -108 ;// Bits per sample is not 8
	public static final int JPG_BAD_COMPNO     = -109 ;// Invalid number of components
	public static final int JPG_BAD_FTYPE      = -110 ;// File type not SOF0 or SOF1
	public static final int JPG_BAD_EOI        = -111 ;// Unexpected End Of Image
	public static final int JPG_BAD_JFIF       = -112 ;// File is not JPEG JFIF
	public static final int JPG_BAD_SCAN_PARAM = -113 ;// Bad progressive JPEG scan parameter
	public static final int JPG_BAD_MEM        = -114 ;// Out of memory
	public static final int JPG_NO_DISK_SPACE  = -115 ;// Out of disk space

	// TIFF extended error codes (available when rcode == BAD_TIFF)
	public static final int TIF_INVALID_DATA= -100   ;// Invalid data found in TIF file     
	public static final int TIF_READ_ERR    = -101   ;// Error reading data from the file   
	public static final int TIF_BAD_EOF     = -102   ;// Unexpected End Of File             
	public static final int TIF_G4_COMPLEX  = -103   ;// Trans point arrays not large enough

	/* Windows related */
	/* Could not lock memory (invalid handle or memory discarded) */
	public static final int BAD_LOCK   = -40;
	public static final int BAD_IBUF   = -42       ;// Invalid image buffer address
	public static final int BAD_PTR    = -52       ;// Pointer does not point at readable/writable memory

	/* Printimage() print modes */
	public static final int PRTDEFAULT = 0;
	public static final int PRTHALFTONE= 1;
	public static final int PRTSCATTER = 2;

	/* Convert8bitto1bit modes */
	public static final int CONV8TO1SCATTER  = 0;
	public static final int CONV8TO1DITHER   = 1;
	public static final int CONV8TO1THRESHOLD= 2;

	/* Colordither, colorscatter modes */
	public static final int COLORSCATTER16 = 0;
	public static final int COLORSCATTER256= 1;
	public static final int COLORDITHER16 = COLORSCATTER16;
	public static final int COLORDITHER256= COLORSCATTER256;

	/* convertrgbtopalmode() modes */
	public static final int CR_OCTREENODIFF = 0; // Use octree color method without error diffusion
	public static final int CR_OCTREEDIFF = 1;   // Use octree color method with error diffusion
	public static final int CR_TSDNODIFF = 2;    // Use TSD color method without error diffusion
	public static final int CR_TSDDIFF = 3;      // Use TSD color method with error diffusion
	public static final int CR_LOW = CR_OCTREENODIFF;
	public static final int CR_HIGH= CR_TSDDIFF;

	/* 24-bit RGB display methods (viewimageex()) */
	public static final int VIEWOPTPAL = 0;
	public static final int VIEWDITHER = 1;
	public static final int VIEWSCATTER= 2;

	/* calchistorgb modes */
	public static final int PALETTEIMAGEASGRAY= 0;
	public static final int PALETTEIMAGEASRGB = 1;

	/* Resize modes */
	public static final int RESIZEFAST= 0;
	public static final int RESIZEBILINEAR= 1;

	/* File save defines */
	public static final int TIFUNC= 0;
	public static final int TIFLZW= 1;
	public static final int TIFPB = 2;
	public static final int TIFG3 = 3;
	public static final int TIFG4 = 4;
	public static final int BMPUNC= 0;
	public static final int BMPRKE= 1;
	public static final int TGAUNC= 0;
	public static final int TGARLE= 1;
	public static final int PIWUNC= 0;
	public static final int PIWRLE= 1;
	public static final int PNGINTERLACE  = 1;
	public static final int PNGALLFILTER  = 0;
	public static final int PNGNOFILTER   = 2;
	public static final int PNGSUBFILTER  = 4;
	public static final int PNGUPFILTER   = 6;
	public static final int PNGAVGFILTER  = 8;
	public static final int PNGPAETHFILTER= 10;
	public static final int PNGALLFILTERS= PNGALLFILTER;
	// Savejpgex() modes
	public static final int JPGSEQ   = 0;
	public static final int JPGPROG  = 1;
	public static final int JPGSEQOPT= 2;
	public static final int JPGSAVETHUMBNAIL= 0x0010;
	public static final int JPGSEQTN   = 0x0010;
	public static final int JPGPROGTN  = 0x0011;
	public static final int JPGSEQOPTTN= 0x0012;
	// Savegifex() mode flags
	public static final int GIFLZWCOMP    = 0;
	public static final int GIFINTERLACE  = 1;
	public static final int GIFTRANSPARENT= 2;
	public static final int GIFWRITE4BIT  = 4;
	public static final int GIFNOCOMP     = 8;
	public static final int GIFMULTIFRAME = 16;


   static {
		System.loadLibrary("vic32jni");
   }
}


